# Generated by Django 4.2.8 on 2023-12-11 11:11

import django.contrib.postgres.fields
from django.db import migrations, models
import django.db.models.deletion
import django.utils.timezone
import model_utils.fields


class Migration(migrations.Migration):
    initial = True

    dependencies = []

    operations = [
        migrations.CreateModel(
            name="CustomField",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "created",
                    model_utils.fields.AutoCreatedField(
                        default=django.utils.timezone.now,
                        editable=False,
                        verbose_name="created",
                    ),
                ),
                (
                    "modified",
                    model_utils.fields.AutoLastModifiedField(
                        default=django.utils.timezone.now,
                        editable=False,
                        verbose_name="modified",
                    ),
                ),
                ("is_removed", models.BooleanField(default=False)),
                ("name", models.CharField(max_length=300)),
                ("multiple", models.BooleanField(default=False)),
                (
                    "input_type",
                    models.CharField(
                        choices=[
                            ("TEXT", "Text"),
                            ("NUMBER", "Number"),
                            ("DATE", "Date"),
                            ("BOOLEAN", "Boolean"),
                            ("DATETIME", "Datetime"),
                            ("CHECKBOX", "Checkbox"),
                            ("RADIO", "Radio"),
                            ("SLIDER", "Slider"),
                            ("PHOTOGRAPH", "Photograph"),
                            ("FILE", "File"),
                            ("LINK", "Link"),
                            ("DOCUMENT", "Document"),
                            ("CPF", "CPF"),
                            ("CNPJ", "CNPJ"),
                            ("MONEY", "Money"),
                        ],
                        default="TEXT",
                        max_length=11,
                    ),
                ),
                (
                    "values",
                    django.contrib.postgres.fields.ArrayField(
                        base_field=models.JSONField(blank=True, null=True),
                        blank=True,
                        default=list,
                        size=None,
                    ),
                ),
                (
                    "keywords",
                    django.contrib.postgres.fields.ArrayField(
                        base_field=models.CharField(
                            blank=True, max_length=200, null=True
                        ),
                        blank=True,
                        default=list,
                        size=None,
                    ),
                ),
            ],
            options={
                "verbose_name": "Custom field",
                "verbose_name_plural": "Custom fields",
                "ordering": ["name"],
            },
        ),
        migrations.CreateModel(
            name="Form",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "created",
                    model_utils.fields.AutoCreatedField(
                        default=django.utils.timezone.now,
                        editable=False,
                        verbose_name="created",
                    ),
                ),
                (
                    "modified",
                    model_utils.fields.AutoLastModifiedField(
                        default=django.utils.timezone.now,
                        editable=False,
                        verbose_name="modified",
                    ),
                ),
                ("name", models.CharField(max_length=255)),
                ("description", models.TextField(blank=True, null=True)),
                ("is_active", models.BooleanField(default=True)),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="Section",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=255)),
                ("description", models.TextField(blank=True, null=True)),
                (
                    "form",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="sections",
                        to="b2_forms.form",
                    ),
                ),
            ],
            options={
                "verbose_name": "Form section",
                "verbose_name_plural": "Form sections",
                "ordering": ["name"],
            },
        ),
        migrations.CreateModel(
            name="Field",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "created",
                    model_utils.fields.AutoCreatedField(
                        default=django.utils.timezone.now,
                        editable=False,
                        verbose_name="created",
                    ),
                ),
                (
                    "modified",
                    model_utils.fields.AutoLastModifiedField(
                        default=django.utils.timezone.now,
                        editable=False,
                        verbose_name="modified",
                    ),
                ),
                ("is_removed", models.BooleanField(default=False)),
                ("index", models.FloatField()),
                ("required", models.BooleanField(default=True)),
                ("form_field", models.BooleanField(default=True)),
                (
                    "custom_field",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="+",
                        to="b2_forms.customfield",
                    ),
                ),
                (
                    "section",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="fields",
                        to="b2_forms.section",
                    ),
                ),
            ],
            options={
                "verbose_name": "Form field",
                "verbose_name_plural": "Form fields",
                "ordering": ["section__form", "section", "index"],
            },
        ),
        migrations.CreateModel(
            name="Answer",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "created",
                    model_utils.fields.AutoCreatedField(
                        default=django.utils.timezone.now,
                        editable=False,
                        verbose_name="created",
                    ),
                ),
                (
                    "modified",
                    model_utils.fields.AutoLastModifiedField(
                        default=django.utils.timezone.now,
                        editable=False,
                        verbose_name="modified",
                    ),
                ),
                ("is_removed", models.BooleanField(default=False)),
                ("name", models.CharField(max_length=300)),
                ("multiple", models.BooleanField(default=False)),
                (
                    "input_type",
                    models.CharField(
                        choices=[
                            ("TEXT", "Text"),
                            ("NUMBER", "Number"),
                            ("DATE", "Date"),
                            ("BOOLEAN", "Boolean"),
                            ("DATETIME", "Datetime"),
                            ("CHECKBOX", "Checkbox"),
                            ("RADIO", "Radio"),
                            ("SLIDER", "Slider"),
                            ("PHOTOGRAPH", "Photograph"),
                            ("FILE", "File"),
                            ("LINK", "Link"),
                            ("DOCUMENT", "Document"),
                            ("CPF", "CPF"),
                            ("CNPJ", "CNPJ"),
                            ("MONEY", "Money"),
                        ],
                        default="TEXT",
                        max_length=11,
                    ),
                ),
                (
                    "values",
                    django.contrib.postgres.fields.ArrayField(
                        base_field=models.JSONField(blank=True, null=True),
                        blank=True,
                        default=list,
                        size=None,
                    ),
                ),
                (
                    "keywords",
                    django.contrib.postgres.fields.ArrayField(
                        base_field=models.CharField(
                            blank=True, max_length=200, null=True
                        ),
                        blank=True,
                        default=list,
                        size=None,
                    ),
                ),
                ("index", models.FloatField()),
                ("required", models.BooleanField(default=True)),
                ("form_field", models.BooleanField(default=True)),
                (
                    "answer",
                    django.contrib.postgres.fields.ArrayField(
                        base_field=models.JSONField(blank=True, null=True),
                        blank=True,
                        default=list,
                        size=None,
                    ),
                ),
                ("mutable", models.BooleanField(default=False)),
                (
                    "field",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="answers",
                        to="b2_forms.field",
                    ),
                ),
            ],
            options={
                "verbose_name": "Answer field",
                "verbose_name_plural": "Answer fields",
                "ordering": ["index"],
            },
        ),
    ]
